var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import * as THREE from 'three';
import { useEffect, useRef, useState } from 'react';
import { Canvas, useFrame } from '@react-three/fiber';
import { useCursor, MeshReflectorMaterial, Image, Environment, } from '@react-three/drei';
import { useRoute, useLocation } from 'wouter';
import getUuid from 'uuid-by-string';
var GOLDENRATIO = 1.61803398875;
// @ts-ignore
// eslint-disable-next-line react/prop-types
var ThreeCover = function (_a) {
    var images = _a.images;
    return (React.createElement(Canvas, { gl: { alpha: false }, dpr: [1, 1.5], camera: { fov: 70, position: [0, 2, 15] } },
        React.createElement("color", { attach: "background", args: ['#191920'] }),
        React.createElement("fog", { attach: "fog", args: ['#191920', 0, 15] }),
        React.createElement(Environment, { preset: "city" }),
        React.createElement("group", { position: [0, -0.5, 0] },
            React.createElement(Frames, { images: images }),
            React.createElement("mesh", { rotation: [-Math.PI / 2, 0, 0], position: [0, 0, 0] },
                React.createElement("planeGeometry", { args: [50, 50] }),
                // @ts-ignore
                React.createElement(MeshReflectorMaterial, { blur: [300, 100], resolution: 2048, mixBlur: 1, mixStrength: 40, roughness: 1, depthScale: 1.2, minDepthThreshold: 0.4, maxDepthThreshold: 1.4, color: "#050505", metalness: 0.5 })))));
};
var Frames = function (_a) {
    var 
    // @ts-ignore
    images = _a.images, _b = _a.q, q = _b === void 0 ? new THREE.Quaternion() : _b, _c = _a.p, p = _c === void 0 ? new THREE.Vector3() : _c;
    var ref = useRef();
    var clicked = useRef();
    var _d = useRoute('/item/:id'), params = _d[1];
    var _e = useLocation(), setLocation = _e[1];
    useEffect(function () {
        // @ts-ignore
        clicked.current = ref.current.getObjectByName(params === null || params === void 0 ? void 0 : params.id);
        if (clicked.current) {
            // @ts-ignore
            clicked.current.parent.updateWorldMatrix(true, true);
            // @ts-ignore
            clicked.current.parent.localToWorld(p.set(0, GOLDENRATIO / 2, 1.25));
            // @ts-ignore
            clicked.current.parent.getWorldQuaternion(q);
        }
        else {
            p.set(0, 0, 5.5);
            q.identity();
        }
    });
    useFrame(function (state) {
        state.camera.position.lerp(p, 0.025);
        state.camera.quaternion.slerp(q, 0.025);
    });
    return (React.createElement("group", { 
        // @ts-ignore
        ref: ref, onClick: function (e) { return (
        // eslint-disable-next-line no-sequences
        e.stopPropagation(),
            setLocation(clicked.current === e.object ? '/' : '/item/' + e.object.name)); }, 
        // eslint-disable-next-line react/no-unknown-property
        onPointerMissed: function () { return setLocation('/'); } }, images.map(function (props) { return (
    // eslint-disable-next-line @typescript-eslint/no-use-before-define
    React.createElement(Frame, __assign({ key: props.url }, props))); })));
};
// @ts-ignore
// eslint-disable-next-line react/prop-types
var Frame = function (_a) {
    var url = _a.url, _b = _a.c, c = _b === void 0 ? new THREE.Color() : _b, props = __rest(_a, ["url", "c"]);
    var _c = useState(false), hovered = _c[0], hover = _c[1];
    var rnd = useState(function () { return Math.random(); })[0];
    var image = useRef();
    var frame = useRef();
    var name = getUuid(url);
    useCursor(hovered);
    useFrame(function (state) {
        // @ts-ignore
        image.current.material.zoom =
            2 + Math.sin(rnd * 10000 + state.clock.elapsedTime / 3) / 2;
        // @ts-ignore
        image.current.scale.x = THREE.MathUtils.lerp(
        // @ts-ignore
        image.current.scale.x, 0.85 * (hovered ? 0.85 : 1), 0.1);
        // @ts-ignore
        image.current.scale.y = THREE.MathUtils.lerp(
        // @ts-ignore
        image.current.scale.y, 0.9 * (hovered ? 0.905 : 1), 0.1);
        // @ts-ignore
        frame.current.material.color.lerp(c.set(hovered ? 'orange' : 'white'), 0.1);
    });
    return (React.createElement("group", __assign({}, props),
        React.createElement("mesh", { name: name, 
            // eslint-disable-next-line no-sequences
            onPointerOver: function (e) { return (e.stopPropagation(), hover(true)); }, onPointerOut: function () { return hover(false); }, scale: [1, GOLDENRATIO, 0.05], 
            // eslint-disable-next-line react/no-unknown-property
            position: [0, GOLDENRATIO / 2, 0] },
            React.createElement("boxGeometry", null),
            React.createElement("meshStandardMaterial", { color: "#151515", 
                // eslint-disable-next-line react/no-unknown-property
                metalness: 0.5, 
                // eslint-disable-next-line react/no-unknown-property
                roughness: 0.5, 
                // eslint-disable-next-line react/no-unknown-property
                envMapIntensity: 2 }),
            React.createElement("mesh", { 
                // @ts-ignore
                ref: frame, 
                // eslint-disable-next-line react/no-unknown-property
                raycast: function () { return null; }, scale: [0.9, 0.93, 0.9], 
                // eslint-disable-next-line react/no-unknown-property
                position: [0, 0, 0.2] },
                React.createElement("boxGeometry", null),
                React.createElement("meshBasicMaterial", { toneMapped: false, fog: false })),
            React.createElement(Image, { raycast: function () { return null; }, 
                // @ts-ignore
                ref: image, position: [0, 0, 0.7], url: url }))));
};
export default ThreeCover;
//# sourceMappingURL=ThreeCover.js.map