'use strict';

var React = require('react');
var THREE = require('three');
var fiber = require('@react-three/fiber');
var drei = require('@react-three/drei');
var wouter = require('wouter');
var getUuid = require('uuid-by-string');
var valtio = require('valtio');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n["default"] = e;
    return Object.freeze(n);
}

var React__namespace = /*#__PURE__*/_interopNamespace(React);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var THREE__namespace = /*#__PURE__*/_interopNamespace(THREE);
var getUuid__default = /*#__PURE__*/_interopDefaultLegacy(getUuid);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

var GOLDENRATIO = 1.61803398875;
// @ts-ignore
// eslint-disable-next-line react/prop-types
var ThreeCover = function (_a) {
    var images = _a.images;
    return (React__namespace.createElement(fiber.Canvas, { gl: { alpha: false }, dpr: [1, 1.5], camera: { fov: 70, position: [0, 2, 15] } },
        React__namespace.createElement("color", { attach: "background", args: ['#191920'] }),
        React__namespace.createElement("fog", { attach: "fog", args: ['#191920', 0, 15] }),
        React__namespace.createElement(drei.Environment, { preset: "city" }),
        React__namespace.createElement("group", { position: [0, -0.5, 0] },
            React__namespace.createElement(Frames, { images: images }),
            React__namespace.createElement("mesh", { rotation: [-Math.PI / 2, 0, 0], position: [0, 0, 0] },
                React__namespace.createElement("planeGeometry", { args: [50, 50] }),
                // @ts-ignore
                React__namespace.createElement(drei.MeshReflectorMaterial, { blur: [300, 100], resolution: 2048, mixBlur: 1, mixStrength: 40, roughness: 1, depthScale: 1.2, minDepthThreshold: 0.4, maxDepthThreshold: 1.4, color: "#050505", metalness: 0.5 })))));
};
var Frames = function (_a) {
    var 
    // @ts-ignore
    images = _a.images, _b = _a.q, q = _b === void 0 ? new THREE__namespace.Quaternion() : _b, _c = _a.p, p = _c === void 0 ? new THREE__namespace.Vector3() : _c;
    var ref = React.useRef();
    var clicked = React.useRef();
    var _d = wouter.useRoute('/item/:id'), params = _d[1];
    var _e = wouter.useLocation(), setLocation = _e[1];
    React.useEffect(function () {
        // @ts-ignore
        clicked.current = ref.current.getObjectByName(params === null || params === void 0 ? void 0 : params.id);
        if (clicked.current) {
            // @ts-ignore
            clicked.current.parent.updateWorldMatrix(true, true);
            // @ts-ignore
            clicked.current.parent.localToWorld(p.set(0, GOLDENRATIO / 2, 1.25));
            // @ts-ignore
            clicked.current.parent.getWorldQuaternion(q);
        }
        else {
            p.set(0, 0, 5.5);
            q.identity();
        }
    });
    fiber.useFrame(function (state) {
        state.camera.position.lerp(p, 0.025);
        state.camera.quaternion.slerp(q, 0.025);
    });
    return (React__namespace.createElement("group", { 
        // @ts-ignore
        ref: ref, onClick: function (e) { return (
        // eslint-disable-next-line no-sequences
        e.stopPropagation(),
            setLocation(clicked.current === e.object ? '/' : '/item/' + e.object.name)); }, 
        // eslint-disable-next-line react/no-unknown-property
        onPointerMissed: function () { return setLocation('/'); } }, images.map(function (props) { return (
    // eslint-disable-next-line @typescript-eslint/no-use-before-define
    React__namespace.createElement(Frame, __assign({ key: props.url }, props))); })));
};
// @ts-ignore
// eslint-disable-next-line react/prop-types
var Frame = function (_a) {
    var url = _a.url, _b = _a.c, c = _b === void 0 ? new THREE__namespace.Color() : _b, props = __rest(_a, ["url", "c"]);
    var _c = React.useState(false), hovered = _c[0], hover = _c[1];
    var rnd = React.useState(function () { return Math.random(); })[0];
    var image = React.useRef();
    var frame = React.useRef();
    var name = getUuid__default["default"](url);
    drei.useCursor(hovered);
    fiber.useFrame(function (state) {
        // @ts-ignore
        image.current.material.zoom =
            2 + Math.sin(rnd * 10000 + state.clock.elapsedTime / 3) / 2;
        // @ts-ignore
        image.current.scale.x = THREE__namespace.MathUtils.lerp(
        // @ts-ignore
        image.current.scale.x, 0.85 * (hovered ? 0.85 : 1), 0.1);
        // @ts-ignore
        image.current.scale.y = THREE__namespace.MathUtils.lerp(
        // @ts-ignore
        image.current.scale.y, 0.9 * (hovered ? 0.905 : 1), 0.1);
        // @ts-ignore
        frame.current.material.color.lerp(c.set(hovered ? 'orange' : 'white'), 0.1);
    });
    return (React__namespace.createElement("group", __assign({}, props),
        React__namespace.createElement("mesh", { name: name, 
            // eslint-disable-next-line no-sequences
            onPointerOver: function (e) { return (e.stopPropagation(), hover(true)); }, onPointerOut: function () { return hover(false); }, scale: [1, GOLDENRATIO, 0.05], 
            // eslint-disable-next-line react/no-unknown-property
            position: [0, GOLDENRATIO / 2, 0] },
            React__namespace.createElement("boxGeometry", null),
            React__namespace.createElement("meshStandardMaterial", { color: "#151515", 
                // eslint-disable-next-line react/no-unknown-property
                metalness: 0.5, 
                // eslint-disable-next-line react/no-unknown-property
                roughness: 0.5, 
                // eslint-disable-next-line react/no-unknown-property
                envMapIntensity: 2 }),
            React__namespace.createElement("mesh", { 
                // @ts-ignore
                ref: frame, 
                // eslint-disable-next-line react/no-unknown-property
                raycast: function () { return null; }, scale: [0.9, 0.93, 0.9], 
                // eslint-disable-next-line react/no-unknown-property
                position: [0, 0, 0.2] },
                React__namespace.createElement("boxGeometry", null),
                React__namespace.createElement("meshBasicMaterial", { toneMapped: false, fog: false })),
            React__namespace.createElement(drei.Image, { raycast: function () { return null; }, 
                // @ts-ignore
                ref: image, position: [0, 0, 0.7], url: url }))));
};

var damp = THREE__namespace.MathUtils.damp;
var state = valtio.proxy({
    clicked: null,
    urls: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 1, 5, 7, 8, 2, 4, 9, 6].map(function (u) { return "/".concat(u, ".jpg"); }),
});

var material = new THREE__namespace.LineBasicMaterial({ color: 'white' });
var geometry = new THREE__namespace.BufferGeometry().setFromPoints([
    new THREE__namespace.Vector3(0, -0.5, 0),
    new THREE__namespace.Vector3(0, 0.5, 0),
]);
function Minimap() {
    var ref = React.useRef();
    var scroll = drei.useScroll();
    var urls = valtio.useSnapshot(state).urls;
    var height = fiber.useThree(function (state) { return state.viewport; }).height;
    fiber.useFrame(function (state, delta) {
        // @ts-ignore
        ref.current.children.forEach(function (child, index) {
            // Give me a value between 0 and 1
            //   starting at the position of my item
            //   ranging across 4 / total length
            //   make it a sine, so the value goes from 0 to 1 to 0.
            var y = scroll.curve(index / urls.length - 1.5 / urls.length, 4 / urls.length);
            child.scale.y = damp(child.scale.y, 0.1 + y / 6, 8, delta);
        });
    });
    return (
    // @ts-ignore
    React__default["default"].createElement("group", { ref: ref }, urls.map(function (_, i) { return (React__default["default"].createElement("line", { key: i, 
        // @ts-ignore
        // eslint-disable-next-line react/no-unknown-property
        geometry: geometry, 
        // @ts-ignore
        // eslint-disable-next-line react/no-unknown-property
        material: material, 
        // @ts-ignore
        // eslint-disable-next-line react/no-unknown-property
        position: [i * 0.06 - urls.length * 0.03, -height / 2 + 0.6, 0] })); })));
}

// @ts-ignore
// eslint-disable-next-line react/prop-types
function Item(_a) {
    var index = _a.index, position = _a.position, scale = _a.scale, _b = _a.c, c = _b === void 0 ? new THREE__namespace.Color() : _b, props = __rest(_a, ["index", "position", "scale", "c"]);
    var ref = React.useRef();
    var scroll = drei.useScroll();
    var _c = valtio.useSnapshot(state), clicked = _c.clicked, urls = _c.urls;
    var _d = React.useState(false), hovered = _d[0], hover = _d[1];
    var click = function () { return (state.clicked = index === clicked ? null : index); };
    var over = function () { return hover(true); };
    var out = function () { return hover(false); };
    fiber.useFrame(function (state, delta) {
        var y = scroll.curve(index / urls.length - 1.5 / urls.length, 4 / urls.length);
        // @ts-ignore
        ref.current.material.scale[1] = ref.current.scale.y = damp(
        // @ts-ignore
        ref.current.scale.y, clicked === index ? 5 : 4 + y, 8, delta);
        // @ts-ignore
        ref.current.material.scale[0] = ref.current.scale.x = damp(
        // @ts-ignore
        ref.current.scale.x, clicked === index ? 4.7 : scale[0], 6, delta);
        if (clicked !== null && index < clicked)
            // @ts-ignore
            ref.current.position.x = damp(
            // @ts-ignore
            ref.current.position.x, position[0] - 2, 6, delta);
        if (clicked !== null && index > clicked)
            // @ts-ignore
            ref.current.position.x = damp(
            // @ts-ignore
            ref.current.position.x, position[0] + 2, 6, delta);
        if (clicked === null || clicked === index)
            // @ts-ignore
            ref.current.position.x = damp(
            // @ts-ignore
            ref.current.position.x, position[0], 6, delta);
        // @ts-ignore
        ref.current.material.grayscale = damp(
        // @ts-ignore
        ref.current.material.grayscale, hovered || clicked === index ? 0 : Math.max(0, 1 - y), 6, delta);
        // @ts-ignore
        ref.current.material.color.lerp(c.set(hovered || clicked === index ? 'white' : '#aaa'), hovered ? 0.3 : 0.1);
    });
    return (React__default["default"].createElement(drei.Image
    // @ts-ignore
    , __assign({ 
        // @ts-ignore
        ref: ref }, props, { position: position, scale: scale, onClick: click, onPointerOver: over, onPointerOut: out })));
}
// eslint-disable-next-line react/prop-types
function Items(_a) {
    var _b = _a.w, w = _b === void 0 ? 0.7 : _b, _c = _a.gap, gap = _c === void 0 ? 0.15 : _c;
    var urls = valtio.useSnapshot(state).urls;
    var width = fiber.useThree(function (state) { return state.viewport; }).width;
    var xW = w + gap;
    return (React__default["default"].createElement(drei.ScrollControls, { horizontal: true, damping: 10, pages: (width - xW + urls.length * xW) / width },
        React__default["default"].createElement(Minimap, null),
        React__default["default"].createElement(drei.Scroll, null, urls.map(function (url, i) { return React__default["default"].createElement(Item, { key: i, index: i, position: [i * xW, 0, 0], scale: [w, 4, 1], url: url }); }) /* prettier-ignore */)));
}
var ThreeSlider = function () { return (React__default["default"].createElement(fiber.Canvas, { gl: { antialias: false }, dpr: [1, 1.5], onPointerMissed: function () { return (state.clicked = null); } },
    React__default["default"].createElement(Items, null))); };

var index = {
    ThreeCover: ThreeCover,
    ThreeSlider: ThreeSlider,
};

module.exports = index;
//# sourceMappingURL=index.js.map
