import * as THREE from 'three';
import React, { useRef } from 'react';
import { useFrame, useThree } from '@react-three/fiber';
import { useScroll } from '@react-three/drei';
import { useSnapshot } from 'valtio';
import { state, damp } from './util';
var material = new THREE.LineBasicMaterial({ color: 'white' });
var geometry = new THREE.BufferGeometry().setFromPoints([
    new THREE.Vector3(0, -0.5, 0),
    new THREE.Vector3(0, 0.5, 0),
]);
export function Minimap() {
    var ref = useRef();
    var scroll = useScroll();
    var urls = useSnapshot(state).urls;
    var height = useThree(function (state) { return state.viewport; }).height;
    useFrame(function (state, delta) {
        // @ts-ignore
        ref.current.children.forEach(function (child, index) {
            // Give me a value between 0 and 1
            //   starting at the position of my item
            //   ranging across 4 / total length
            //   make it a sine, so the value goes from 0 to 1 to 0.
            var y = scroll.curve(index / urls.length - 1.5 / urls.length, 4 / urls.length);
            child.scale.y = damp(child.scale.y, 0.1 + y / 6, 8, delta);
        });
    });
    return (
    // @ts-ignore
    React.createElement("group", { ref: ref }, urls.map(function (_, i) { return (React.createElement("line", { key: i, 
        // @ts-ignore
        // eslint-disable-next-line react/no-unknown-property
        geometry: geometry, 
        // @ts-ignore
        // eslint-disable-next-line react/no-unknown-property
        material: material, 
        // @ts-ignore
        // eslint-disable-next-line react/no-unknown-property
        position: [i * 0.06 - urls.length * 0.03, -height / 2 + 0.6, 0] })); })));
}
//# sourceMappingURL=Minimap.js.map